"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const prepend_file_1 = __importDefault(require("prepend-file"));
const util_1 = require("util");
const fs_1 = require("fs");
const SHEBANG = "#!/usr/bin/env node\n";
const readFile = util_1.promisify(fs_1.readFile);
const prependFile = util_1.promisify(prepend_file_1.default);
function addSebangToFile(file) {
    return __awaiter(this, void 0, void 0, function* () {
        yield prependFile(file, SHEBANG);
    });
}
function values(obj) {
    const values = [];
    for (const key in obj) {
        values.push(obj[key]);
    }
    return values;
}
function addShebang() {
    return __awaiter(this, void 0, void 0, function* () {
        const packageJson = JSON.parse((yield readFile("./package.json")).toString());
        if (packageJson.bin === undefined)
            return; // TODO maybe should throw error
        const files = typeof packageJson.bin === "string"
            ? [packageJson.bin]
            : Array.isArray(packageJson.bin)
                ? packageJson.bin
                : values(packageJson.bin);
        yield Promise.all(files.map(addSebangToFile));
    });
}
exports.addShebang = addShebang;
